program apend02;
{$F+}
{
***********************************************************
"Fourier: Ejemplo de funcion: Pulso rectangular peridico"
Autores: JRomero - Arodri
Fecha: 18-04-98

	El valor de fo es 50HZ

**********************************************************
}

uses
wincrt, xmatdefs, FilUSR, UCntrl, Simul4, traxp, variable,
lib_basi, libep02, libep, libdig01, PlotMems, memorias;

const w=PI*100;           {frecuencia de red=50 hz}
		f0=50;					{frecuencia de red}
		periodo=20e-3;
		grillay=10;          {divisiones de la grilla en y}
		grillax=6;			  {divisiones de la grilla en x}
		nper=1;				  {nmero de periodos a visualizar   (nper>=1)}
		npuntos=128;
var
		{variables para seleccionar T de la funcin a graficar}
		Tpedido:NReal;
		Tactual:NReal;
		LOOP_POR_T:Boolean; {ver pesca}

		{para calcular armonicos}
		mem1:Tmemoria;


(***********************************************************************
	Funciones de definicin del circuito

	Cirt1: componentes no booleanos
	Cirt2: componentes booleanos
***********************************************************************)

procedure cirt1;
begin
	vg(1,0,1,1);
	r(1,0,100);
end;

procedure cirt2;
begin
end;


(************************************************************************
	Definicin de la seal del generador VG[1]
************************************************************************)
procedure funcsr(t:NReal);
var 	F:NReal;
begin
if t<Tactual then F:=-1
else if t<(10e-3-Tactual) then F:=0
else if t<(10e-3+Tactual) then F:=1
else if t<(20e-3-Tactual) then F:=0
else F:=-1;

rf[1]:=F;
end;




(************************************************************************
	Procedimientos necesarios de Simeep:

	inicio:	inicializacin de simulaciones, def. de pantalla,etc
	pesca: 	captura e impresin en pantalla de variables observadas
	fin:     procedimiento de finalizacin

************************************************************************)

procedure inicio;
begin
	nn:=1;					{nmero de nodos, sin incluir tierra (0)}
	nindep:=3;     		{nmero de funciones definidas en funcsr = numero de generadores}
	tinicial:=0;			{tiempo inicial de la simulacin}
	tfinal:=nper*periodo;	{tiempo final de la simulacin}


	{parmetros de simulacin}
	dtmax0:=5e-6;
	dtmin:=dtmax0/100;
	PasoDivisor:=6;
	TmaxTmin:=1e3;

	{inicializacin de la unidad de grficos}
	traxp.tinicial:=tinicial;
	traxp.tfinal:=tfinal;


	{inicializacin del modo grfico}
	iniciegr;

	{grillas en pantalla}
	gridx:=grillax;
	gridy:=grillay;

	{matriz de visualizacin de 1 por 4}
	subplot(1,2);


	{primera pantalla}
	definaY(0,-1.25,0.25);
	titulo('Funcin Pulso rectangular');
	xlabel('');
	ylabel('250mV/DIV');
	linea0;
	grid;

	{segunda pantalla}
	definaY(1,0,10);
	titulo('Magnitud de armnicos (1-25) respecto al primero.');

	definacolor(0,rojo);


end;

{____________________________________________________________________}

procedure fin;
begin
TermineGr;
halt;
end;

{____________________________________________________________________}

procedure pesca;
var   k:integer;
		tanterior:NReal;
begin
	if not LOOP_POR_T then
	begin
		traxp.t:=t;					{indicamos a traxp el tiempo de simulacin}

		mem1.tic(t,(v[1]));

		trazo(0,v[1]+0.01);
		trazo(0,v[1]-0.01);

		if t >= tfinal then
		begin
		{llegamos al final de la simulacin}

		{ahora debmos arreglar la visualizacin de armonicos,
		 por si debemos entrar en un LOOP_POR_NFUNCION}
		borrecanal(1,0);
		desligue(1);
		borde;

		mem1.fft;								{calcular FFT de mem1}
		PlotMem_EspectroUnU1Bar_0_25(1,mem1);	{mostrar armonicos calculados de mem1}
		gridx:=grillax;						{forzar grilla al valor por defecto}
		gridy:=grillay;						{forzar grilla al valor por defecto}
		mem1.RetrocesoBarrido(tfinal-tinicial);{preparar nueva carga de datos}


		{******* ESPERAR SI NO SE CAMBIA EL NUMERO DE FUNCION **********}
		{si no cambio Tactual, no se hace una nueva simulacin
		 Esto se logra preguntando por la bandera LOOP_POR_T
		 al empezar pesca, y luego forzar un loop llamando
		 a FilUsr.Pesca, que en realidad llama a UCNTRL.PESCA (privado)
		 que manaja los controles.

		 Esta funcion llama a esta pesca, por lo que debemos evitar
		 recursividad, y para ello seteamos a TRUE si estamos en un
		 LOOP POR T}

		Tanterior:=Tactual;
		Tactual:=Tpedido;
		if Tanterior=Tactual then
		begin
			LOOP_POR_T:=true;
			while Tanterior=Tactual do
			begin
				FilUsr.pesca;	{ucntrl.Pesca que es privada}
				Tactual:=Tpedido;
			end;
			LOOP_POR_T:=false;
		end;


		{ahora se puede borrar la pantalla 1, antes la borraria durante
		LOOP_POR_NFUNCION}
		borrecanal(0,0);
		desligue(0);
		borde;
		grid;
		linea0;

		{nueva simulacin}
		t:= t-tfinal+tinicial;



		end;
	end;
end;


(*********************************************************************
 Principal
*********************************************************************)
BEGIN
	quita:=5;			{separaciones de pantallas}

	{variables para seleccionar funcin a visualizar}
	Tactual:=3.3e-3;
	LOOP_POR_T:=false;	{ver pesca}

	{decimos a simeep donde estan nuestras funciones}
	FilUSR.Cirt1:=Cirt1;
	FilUSR.Cirt2:=Cirt2;
	FilUSR.FuncsR:=FuncsR;
	FilUSR.Inicio:=Inicio;
	FilUSR.Pesca:=Pesca;
	FilUSR.Fin:=Fin;


	mem1:= TMemoria.Create_init(periodo/npuntos,npuntos,0,0);

	{definicin de controles}
	UCntrl.init;

	UCntrl.insertdisplay(new(PCtrlVerTexto, init
	{ rnglon, texto1  ,            texto2,             texto3}
	(	0,	'Analizando Espectros','--------------------','')));

	UCntrl.insert(new(PCtrlBotonVar,Init
	{renglon, nombre,   unidad,decimales, min, max,   def, inc,    var}
	(  8,   '     T',  'mS'  ,1        ,   1,   5,     3.3,  0.1,  Tpedido)));


	paseo;												  {simulacin}

	mem1.Free;

end.
